/* Copyright (c) 2010 Ondrej Donek.
 * See the file LICENSE.txt for licensing information. */

// Namespace
if(typeof(xpcomviewer.bookmarks) == "undefined") xpcomviewer.bookmarks = {};
// Implementation
(function() {
	
	/**
	 * Prepare database.
	 * 
	 * @private
	 * @returns {void}
	 */
	this.prepareDb = function()
	{
		let _DB = xpcomviewer.global.getDb();
		
		_DB.executeSimpleSQL(
			"CREATE TABLE IF NOT EXISTS bookmarks (" + 
			"  target VARCHAR NOT NULL ," +
			"  since DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP " + 
			")"
		);
	}; // end prepareDb()
	
	
	/** 
	 * Returns TRUE if there is an existing bookmark for given target.
	 * 
	 * @param aTarget {string}
	 * @returns {void}
	 */
	this.hasBookmark = function(aTarget)
	{
		let _DB = xpcomviewer.global.getDb();
		
		let stmt = _DB.createStatement(
				"SELECT * FROM bookmarks WHERE target='" + aTarget + "' LIMIT 1 "
		);
		
		while(stmt.executeStep()) {
			return true;
		}
		return false;
	}; // end hasBookmark(aTarget)
	
	
	/** 
	 * Creates bookmark for given target.
	 * 
	 * @param aTarget {string}
	 * @returns {void}
	 */
	this.createBookmark = function(aTarget)
	{
		let _DB = xpcomviewer.global.getDb();
		
		_DB.createStatement(
				"INSERT INTO bookmarks VALUES ('" + aTarget + "', CURRENT_TIMESTAMP) "
		).execute();
	}; // end createBookmark(aTarget)
	
	
	/** 
	 * Deletes bookmark with given target.
	 * 
	 * @param aTarget {string}
	 * @returns {void}
	 */
	this.deleteBookmark = function(aTarget)
	{
		let _DB = xpcomviewer.global.getDb();
		
		_DB.executeSimpleSQL(
				"DELETE FROM bookmarks WHERE target='" + aTarget + "' "
		);
	}; // end deleteBookmark(aTarget)
	
}).apply(xpcomviewer.bookmarks);
