/* Copyright (c) 2010 Ondrej Donek.
 * See the file LICENSE.txt for licensing information. */

// Namespace
if(typeof(xvTemplatesDlg) == "undefined") var xvTemplatesDlg = {};
// Implementation
(function() {
	
	this.getXpcomviewer = function()
	{
		let wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
				getService(Components.interfaces.nsIWindowMediator);  
		let mainWindow = wm.getMostRecentWindow("xpcomviewer");
		
		return mainWindow;
	}; // end getXpcomviewer()
	
	this.onAccept = function(aEvent) 
	{ 
		return true; 
	}; // end onAccept(aEvent)
	
	this.onLoadTplCmd = function(aEvent) 
	{
		let langList = document.getElementById("language-menulist");
		let typeList = document.getElementById("template-menulist");
		let srcTbox = document.getElementById("source-textbox");
		let loadBtn = document.getElementById("load-button");
		let closeBtn = document.getElementById("close-button");
		let saveBtn = document.getElementById("save-button");
		
		let xv = this.getXpcomviewer();
		let lang = langList.value;
		let type = typeList.value;
		let tpl = xv.xpcomviewer.templates.getTemplateSource(type, lang);
		
		if(tpl == null || tpl == "") {
			xv.xpcomviewer.global.showAlert("noTemplateMsg", "showNoTemplateAlert");
			tpl = "";
		}
		
		langList.disabled = true;
		typeList.disabled = true;
		loadBtn.disabled = true;
		closeBtn.disabled = false;
		saveBtn.disabled = false;
		srcTbox.value = tpl;
		srcTbox.disabled = false;
	}; // end onLoadTplCmd(aEvent)
	
	this.onCloseTplCmd = function(aEvent) 
	{
		let langList = document.getElementById("language-menulist");
		let typeList = document.getElementById("template-menulist");
		let srcTbox = document.getElementById("source-textbox");
		let loadBtn = document.getElementById("load-button");
		let closeBtn = document.getElementById("close-button");
		let saveBtn = document.getElementById("save-button");
		
		langList.value = "---";
		langList.disabled = false;
		typeList.disabled = false;
		typeList.value = "---";
		loadBtn.disabled = false;
		closeBtn.disabled = true;
		saveBtn.disabled = true;
		srcTbox.value = "";
		srcTbox.disabled = true;
	}; // end onCloseTplCmd(aEvent)
	
	this.onSaveTplCmd = function(aEvent) 
	{ 
		let langList = document.getElementById("language-menulist");
		let typeList = document.getElementById("template-menulist");
		let srcTbox = document.getElementById("source-textbox");
		
		let xv = this.getXpcomviewer();
		let lang = langList.value;
		let type = typeList.value;
		let tpl = srcTbox.value;
		
		xv.xpcomviewer.templates.setTemplateSource(type, lang, tpl);
		
		this.onCloseTplCmd(aEvent);
	}; // end onSaveTplCmd(aEvent)
	
}).apply(xvTemplatesDlg);